package main

import (
	"flag"
	"fmt"
	"net/http"
	"time"

	"fusenapi/utils/auth"
	"fusenapi/utils/fsconfig"

	{{.importPackages}}
)

var configFile = flag.String("f", "etc/{{.serviceName}}.yaml", "the config file")

func main() {
	flag.Parse()

	var c config.Config
	fsconfig.StartNacosConfig(*configFile, &c, nil)
 	
	c.Timeout = int64(time.Second * 15)
	server := rest.MustNewServer(c.RestConf, rest.WithCustomCors(auth.FsCors, func(w http.ResponseWriter) {
	}))
	defer server.Stop()

	ctx := svc.NewServiceContext(c)
	handler.RegisterHandlers(server, ctx)

	fmt.Printf("Starting server at %s:%d...\n", c.Host, c.Port)
	server.Start()
}


 