package gmodel

import (
	"gorm.io/gorm"
	"time"
)

// fs_admin_department 后台--部门表
type FsAdminDepartment struct {
	Id         int64      `gorm:"primary_key;default:0;auto_increment;" json:"id"`   // 序号
	DeptPid    *int64     `gorm:"default:0;" json:"dept_pid"`                        // 上级部门
	DeptNo     *string    `gorm:"default:'';" json:"dept_no"`                        //
	DeptName   *string    `gorm:"unique_key;default:'';" json:"dept_name"`           //
	ShortName  *string    `gorm:"default:'';" json:"short_name"`                     //
	UserId     *int64     `gorm:"default:0;" json:"user_id"`                         // 部门负责人
	Phone      *string    `gorm:"default:'';" json:"phone"`                          //
	Status     *int64     `gorm:"default:2;" json:"status"`                          // 状态:1=启用,2=停用
	Remark     *string    `gorm:"default:'';" json:"remark"`                         //
	Sort       *int64     `gorm:"default:0;" json:"sort"`                            // 排序权重
	CreateTime *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"create_time"` //
	UpdateTime *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"update_time"` //
	DeleteTime *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"delete_time"` //
	CreateUid  *int64     `gorm:"default:0;" json:"create_uid"`                      // 创建人
	UpdateUid  *int64     `gorm:"default:0;" json:"update_uid"`                      // 更新人
	DeleteUid  *int64     `gorm:"default:0;" json:"delete_uid"`                      // 删除人
	IsDel      *int64     `gorm:"default:0;" json:"is_del"`                          // 是否删除：1=是 0=否
}
type FsAdminDepartmentModel struct {
	db   *gorm.DB
	name string
}

func NewFsAdminDepartmentModel(db *gorm.DB) *FsAdminDepartmentModel {
	return &FsAdminDepartmentModel{db: db, name: "fs_admin_department"}
}
