package gmodel

import (
	"gorm.io/gorm"
)

// fs_cloud_receive_old 云仓接收工厂总单
type FsCloudReceiveOld struct {
	Id       int64   `gorm:"primary_key;default:0;auto_increment;" json:"id"` //
	CloudId  *int64  `gorm:"index;default:0;" json:"cloud_id"`                // 入库云仓id
	AdminId  *int64  `gorm:"index;default:0;" json:"admin_id"`                // 操作员id
	UserId   *int64  `gorm:"index;default:0;" json:"user_id"`                 // 用户id
	OrderId  *int64  `gorm:"index;default:0;" json:"order_id"`                // 入库云仓的订单
	Fee      *int64  `gorm:"default:0;" json:"fee"`                           // 运费
	Delivery *string `gorm:"default:'';" json:"delivery"`                     //
	Ctime    *int64  `gorm:"default:0;" json:"ctime"`                         // 创建时间
	Status   *int64  `gorm:"default:0;" json:"status"`                        // 0未收到  1收到
}
type FsCloudReceiveOldModel struct {
	db   *gorm.DB
	name string
}

func NewFsCloudReceiveOldModel(db *gorm.DB) *FsCloudReceiveOldModel {
	return &FsCloudReceiveOldModel{db: db, name: "fs_cloud_receive_old"}
}
