package gmodel

import (
	"gorm.io/gorm"
)

// fs_cloud_storage 仓库的基本信息, 只做映射
type FsCloudStorage struct {
	CloudStorageId *string `gorm:"unique_key;default:'';" json:"cloud_storage_id"` //
	Name           *string `gorm:"default:'';" json:"name"`                        // 仓库的名字, 中文使用拼音,国外使用英文
	Address        *string `gorm:"default:'';" json:"address"`                     // 仓库地址
	Contact        *[]byte `gorm:"default:'';" json:"contact"`                     //
	Ownership      *int64  `gorm:"default:0;" json:"ownership"`                    // 0为自有, 1为第三方, 后期可以自由定制
	Scope          *[]byte `gorm:"default:'';" json:"scope"`                       //
	Capacity       *[]byte `gorm:"default:'';" json:"capacity"`                    //
	Metadata       *[]byte `gorm:"default:'';" json:"metadata"`                    //
}
type FsCloudStorageModel struct {
	db   *gorm.DB
	name string
}

func NewFsCloudStorageModel(db *gorm.DB) *FsCloudStorageModel {
	return &FsCloudStorageModel{db: db, name: "fs_cloud_storage"}
}
