package gmodel

import (
	"gorm.io/gorm"
	"time"
)

// fs_guest 游客表
type FsGuest struct {
	GuestId int64      `gorm:"primary_key;default:0;auto_increment;" json:"guest_id"` // ID
	AuthKey *string    `gorm:"default:'';" json:"auth_key"`                           // jwt token
	Status  *int64     `gorm:"index;default:1;" json:"status"`                        // 1正常 0不正常
	IsDel   *int64     `gorm:"index;default:0;" json:"is_del"`                        // 是否删除 1删除
	Ctime   *time.Time `gorm:"index;default:'0000-00-00 00:00:00';" json:"ctime"`     //
	Utime   *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"utime"`           //
}
type FsGuestModel struct {
	db   *gorm.DB
	name string
}

func NewFsGuestModel(db *gorm.DB) *FsGuestModel { return &FsGuestModel{db: db, name: "fs_guest"} }
