package gmodel

import (
	"gorm.io/gorm"
)

// fs_log 日志表
type FsLog struct {
	Id          int64   `gorm:"primary_key;default:0;auto_increment;" json:"id"` // ID
	Action      *string `gorm:"default:'';" json:"action"`                       //
	Table       *string `gorm:"default:'';" json:"table"`                        //
	DataChanged *string `gorm:"default:'';" json:"data_changed"`                 // 修改后的数据
	DataOld     *string `gorm:"default:'';" json:"data_old"`                     // 变动的数据
	Ctime       *int64  `gorm:"default:0;" json:"ctime"`                         // 添加时间
	Uid         *int64  `gorm:"default:0;" json:"uid"`                           // 操作人ID
	Uname       *string `gorm:"default:'';" json:"uname"`                        //
}
type FsLogModel struct {
	db   *gorm.DB
	name string
}

func NewFsLogModel(db *gorm.DB) *FsLogModel { return &FsLogModel{db: db, name: "fs_log"} }
