package gmodel

import (
	"gorm.io/gorm"
	"time"
)

// fs_order_trade_event 订单交易事件表
type FsOrderTradeEvent struct {
	Id        int64      `gorm:"primary_key;default:0;auto_increment;" json:"id"` // 订单交易ID
	PayMethod *int64     `gorm:"default:0;" json:"pay_method"`                    // 支付方式：1=stripe，2=paypal
	EventId   *string    `gorm:"default:'';" json:"event_id"`                     //
	EventType *string    `gorm:"default:'';" json:"event_type"`                   //
	EventData *[]byte    `gorm:"default:'';" json:"event_data"`                   //
	Ctime     *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"ctime"`     //
	Utime     *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"utime"`     //
}
type FsOrderTradeEventModel struct {
	db   *gorm.DB
	name string
}

func NewFsOrderTradeEventModel(db *gorm.DB) *FsOrderTradeEventModel {
	return &FsOrderTradeEventModel{db: db, name: "fs_order_trade_event"}
}
