package gmodel

import (
	"gorm.io/gorm"
	"time"
)

// fs_product_collection 产品收藏表
type FsProductCollection struct {
	Id               int64      `gorm:"primary_key;default:0;auto_increment;" json:"id"` // id
	UserId           *int64     `gorm:"default:0;" json:"user_id"`                       // 用户id
	GuestId          *int64     `gorm:"default:0;" json:"guest_id"`                      // 游客id
	ProductId        *int64     `gorm:"default:0;" json:"product_id"`                    // 产品id
	TemplateTag      *string    `gorm:"default:'';" json:"template_tag"`                 //
	SelectColorIndex *int64     `gorm:"default:0;" json:"select_color_index"`            // 选择的颜色索引
	Logo             *string    `gorm:"default:'';" json:"logo"`                         // logo地址
	Ctime            *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"ctime"`     //
	Utime            *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"utime"`     //
}
type FsProductCollectionModel struct {
	db   *gorm.DB
	name string
}

func NewFsProductCollectionModel(db *gorm.DB) *FsProductCollectionModel {
	return &FsProductCollectionModel{db: db, name: "fs_product_collection"}
}
