package gmodel

import (
	"gorm.io/gorm"
)

// fs_product_template_tags  模板标签表
type FsProductTemplateTags struct {
	Id          int64   `gorm:"primary_key;default:0;auto_increment;" json:"id"` // ID
	TemplateTag *string `gorm:"unique_key;default:'';" json:"template_tag"`      //
	Cover       *string `gorm:"default:'';" json:"cover"`                        // 缩略图
	Status      *int64  `gorm:"default:0;" json:"status"`                        // 状态 1：可用
	IsHide      *int64  `gorm:"default:0;" json:"is_hide"`                       // 是否隐藏
	CreateAt    *int64  `gorm:"default:0;" json:"create_at"`                     // 创建时间
	Groups      *string `gorm:"default:'';" json:"groups"`                       // 分组信息
}
type FsProductTemplateTagsModel struct {
	db   *gorm.DB
	name string
}

func NewFsProductTemplateTagsModel(db *gorm.DB) *FsProductTemplateTagsModel {
	return &FsProductTemplateTagsModel{db: db, name: "fs_product_template_tags"}
}
