package gmodel

import (
	"gorm.io/gorm"
)

// fs_tags 产品分类表
type FsTags struct {
	Id                   int64   `gorm:"primary_key;default:0;auto_increment;" json:"id"` // ID
	LevelPrefix          *string `gorm:"default:'';" json:"level_prefix"`                 //
	Title                *string `gorm:"default:'';" json:"title"`                        // 标题
	Level                *int64  `gorm:"default:0;" json:"level"`                         // 层级、分类 1 => 二维码分类 2网站分类 3,3d设计工具分类
	ClickNum             *int64  `gorm:"default:0;" json:"click_num"`                     // 点击次数
	Sort                 *int64  `gorm:"default:0;" json:"sort"`                          // 排序(从大到小)
	CreateAt             *int64  `gorm:"default:0;" json:"create_at"`                     // 创建时间
	Icon                 *string `gorm:"default:'';" json:"icon"`                         // 标签图标
	Status               *int64  `gorm:"default:1;" json:"status"`                        // 状态 1：可用
	Description          *string `gorm:"default:'';" json:"description"`                  // 介绍 Seo
	RecommendProduct     *string `gorm:"default:'';" json:"recommend_product"`            // 推荐产品id例如: 1,3,4,5
	RecommendProductSort *string `gorm:"default:'';" json:"recommend_product_sort"`       // 推荐排序例如:1324
	Category             *int64  `gorm:"default:1;" json:"category"`                      // 分类：1前台用的 2后台用的
}
type FsTagsModel struct {
	db   *gorm.DB
	name string
}

func NewFsTagsModel(db *gorm.DB) *FsTagsModel { return &FsTagsModel{db: db, name: "fs_tags"} }
