package gmodel

import (
	"gorm.io/gorm"
	"time"
)

// fs_user_info 用户信息表
type FsUserInfo struct {
	Id       int64      `gorm:"primary_key;default:0;auto_increment;" json:"id"` // ID
	Module   *string    `gorm:"default:'';" json:"module"`                       // 所属模块
	UserId   *int64     `gorm:"index;default:0;" json:"user_id"`                 // 用户 ID
	GuestId  *int64     `gorm:"index;default:0;" json:"guest_id"`                // 访客 ID
	Metadata *[]byte    `gorm:"default:'';" json:"metadata"`                     // 元数据,json格式
	Ctime    *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"ctime"`     //
	Utime    *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"utime"`     //
}
type FsUserInfoModel struct {
	db   *gorm.DB
	name string
}

func NewFsUserInfoModel(db *gorm.DB) *FsUserInfoModel {
	return &FsUserInfoModel{db: db, name: "fs_user_info"}
}
