package gmodel

import (
	"gorm.io/gorm"
	"time"
)

// fs_user_material 用户素材表
type FsUserMaterial struct {
	Id          int64      `gorm:"primary_key;default:0;auto_increment;" json:"id"` // 用户 ID
	Module      *string    `gorm:"default:'';" json:"module"`                       //
	UserId      *int64     `gorm:"index;default:0;" json:"user_id"`                 // 用户 ID
	GuestId     *int64     `gorm:"index;default:0;" json:"guest_id"`                // 游客 ID
	ResourceId  *string    `gorm:"default:'';" json:"resource_id"`                  //
	ResourceUrl *string    `gorm:"default:'';" json:"resource_url"`                 //
	Metadata    *[]byte    `gorm:"default:'';" json:"metadata"`                     //
	Ctime       *time.Time `gorm:"default:'0000-00-00 00:00:00';" json:"ctime"`     // 上传时间
}
type FsUserMaterialModel struct {
	db   *gorm.DB
	name string
}

func NewFsUserMaterialModel(db *gorm.DB) *FsUserMaterialModel {
	return &FsUserMaterialModel{db: db, name: "fs_user_material"}
}
