package svc

import (
	"fusenapi/initalize"
	"fusenapi/model/gmodel"
	"fusenapi/server/collection/internal/config"
	"gorm.io/gorm"
)

type ServiceContext struct {
	Config    config.Config
	MysqlConn *gorm.DB
	AllModels *gmodel.AllModelsGen
	RabbitMq  *initalize.RabbitMqHandle
}

func NewServiceContext(c config.Config) *ServiceContext {
	conn := initalize.InitMysql(c.SourceMysql)

	return &ServiceContext{
		Config:    c,
		MysqlConn: conn,
		AllModels: gmodel.NewAllModels(initalize.InitMysql(c.SourceMysql)),
		RabbitMq:  initalize.InitRabbitMq(c.SourceRabbitMq, nil),
	}
}
