// Code generated by goctl. DO NOT EDIT.
package types

import (
	"fusenapi/utils/basic"
)

type CollectProductReq struct {
	ProductId        int64  `json:"product_id"`
	Logo             string `json:"logo"`
	SelectColorIndex int64  `json:"select_color_index"`
	TemplateTag      string `json:"template_tag"`
}

type DeleteCollectProductReq struct {
	Ids []int64 `json:"ids"`
}

type GetCollectProductListReq struct {
	CurrentPage int `form:"current_page"`
}

type GetCollectProductListRsp struct {
	Meta Meta                           `json:"meta"` //分页信息
	List []GetCollectProductListRspItem `json:"list"`
}

type GetCollectProductListRspItem struct {
	Id               int64       `json:"id"`
	ProductId        int64       `json:"product_id"`
	ProductName      string      `json:"product_name"`
	Logo             string      `json:"logo"`
	Cover            string      `json:"cover"`
	CoverMetadata    interface{} `json:"coverMetadata"`
	SelectColorIndex int64       `json:"select_color_index"`
	TemplateTag      string      `json:"template_tag"`
	SizeCount        int64       `json:"size_count"`
	MinPrice         string      `json:"min_price"`
	IsShelf          int64       `json:"is_shelf"`
	IsDeleted        int64       `json:"is_deleted"`
}

type TestAiReq struct {
	Num int `form:"num"`
}

type TestPdfReq struct {
	Content string `json:"content"`
	Type    string `json:"type"`
}

type Request struct {
}

type Response struct {
	Code    int         `json:"code"`
	Message string      `json:"msg"`
	Data    interface{} `json:"data"`
}

type Auth struct {
	AccessSecret string `json:"accessSecret"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type File struct {
	Filename string              `fsfile:"filename"`
	Header   map[string][]string `fsfile:"header"`
	Size     int64               `fsfile:"size"`
	Data     []byte              `fsfile:"data"`
}

type Meta struct {
	TotalCount  int64 `json:"total_count"`
	PageCount   int64 `json:"page_count"`
	CurrentPage int   `json:"current_page"`
	PerPage     int   `json:"per_page"`
}

// Set 设置Response的Code和Message值
func (resp *Response) Set(Code int, Message string) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
	}
}

// Set 设置整个Response
func (resp *Response) SetWithData(Code int, Message string, Data interface{}) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
		Data:    Data,
	}
}

// SetStatus 设置默认StatusResponse(内部自定义) 默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatus(sr *basic.StatusResponse, data ...interface{}) *Response {
	newResp := &Response{
		Code: sr.Code,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}

// SetStatusWithMessage 设置默认StatusResponse(内部自定义) 非默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatusWithMessage(sr *basic.StatusResponse, msg string, data ...interface{}) *Response {
	newResp := &Response{
		Code:    sr.Code,
		Message: msg,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}
