package config

import (
	"fusenapi/server/home-user-auth/internal/types"

	"github.com/zeromicro/go-zero/rest"
)

type Config struct {
	rest.RestConf
	SourceMysql string
	Auth        types.Auth
	ReplicaId   uint64

	MainAddress string

	Stripe struct {
		SK string
	}

	PayConfig struct {
		Stripe struct {
			EndpointSecret string
			Key            string
			CancelURL      string
			SuccessURL     string
		}
	}
	AWS struct {
		S3 struct {
			Credentials struct {
				AccessKeyID string
				Secret      string
				Token       string
			}
		}
	}
	BLMService struct {
		Version string
		Urls    []string
	}
}
