package logic

import (
	"fusenapi/utils/auth"
	"fusenapi/utils/basic"

	"context"

	"fusenapi/server/info/internal/svc"
	"fusenapi/server/info/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type RestaurantListLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewRestaurantListLogic(ctx context.Context, svcCtx *svc.ServiceContext) *RestaurantListLogic {
	return &RestaurantListLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

// 处理进入前逻辑w,r
// func (l *RestaurantListLogic) BeforeLogic(w http.ResponseWriter, r *http.Request) {
// }

func (l *RestaurantListLogic) RestaurantList(req *types.Request, userinfo *auth.UserInfo) (resp *basic.Response) {
	// 返回值必须调用Set重新返回, resp可以空指针调用 resp.SetStatus(basic.CodeOK, data)
	// userinfo 传入值时, 一定不为null

	values := []string{
		"Pizza Shop",
		"Coffee Shop",
		"Salad Shop",
		"Other Non-Asian Restaurants",
		"Fried Chicken / Burger / Sandwich Restaurant",
		"Other Restaurants",
		"Bakery / Dessert Shop",
		"Ramen /Vietnamese / Thai / Korean / Chinese",
		"Breakfast & Brunch",
		"Moxican",
		"Pho",
		"Ramen",
		"Chinese",
		"Burgers",
		"Sushi Restaurant",
		"Indian",
		"Vegan",
		"Smoothie",
		"Healthy",
		"Soup",
		"Italian",
		"Boba Tea Shop",
		"Other",
		"Korean / Thai",
		"Bar",
	}

	return resp.SetStatus(basic.CodeOK, values)
}

// 处理逻辑后 w,r 如:重定向, resp 必须重新处理
// func (l *RestaurantListLogic) AfterLogic(w http.ResponseWriter, r *http.Request, resp *basic.Response) {
// // httpx.OkJsonCtx(r.Context(), w, resp)
// }
