// Code generated by goctl. DO NOT EDIT.
package types

import (
	"fusenapi/utils/basic"
)

type GetRecommandProductListReq struct {
	Size int32  `form:"size,optional"`
	Num  int64  `form:"num,optional"`
	Sn   string `form:"sn"`
}

type GetRecommandProductListRsp struct {
	Id               int64              `json:"id"`
	Sn               string             `json:"sn"`
	Title            string             `json:"title"`
	TitleCn          string             `json:"title_cn"`
	Cover            string             `json:"cover"`
	CoverMetadata    interface{}        `json:"cover_metadata"`
	CoverImg         string             `json:"cover_img"`
	CoverImgMetadata interface{}        `json:"cover_img_metadata"`
	CoverDefault     []CoverDefaultItem `json:"cover_default"`
	Intro            string             `json:"intro"`
	Recommend        bool               `json:"recommend"`
	MinPrice         int64              `json:"min_price"`
	IsCustomization  int64              `json:"is_customization"`
}

type GetTagProductListReq struct {
	Cid         int64  `form:"cid,optional"`          //分类id
	Size        uint32 `form:"size,optional"`         //尺寸
	TemplateTag string `form:"template_tag,optional"` //模板标签
	WithProduct bool   `form:"with_product,optional"` //是否携带分类下的产品
}

type GetTagProductListRsp struct {
	TotalCategoryProduct int       `json:"total_category_product"`
	TagList              []TagItem `json:"tag_list"`
}

type TagItem struct {
	TypeName       string        `json:"type_name"`
	TypeId         int64         `json:"type_id"`
	Icon           string        `json:"icon"`
	Sort           int64         `json:"sort"`
	LevelPrefix    string        `json:"level_prefix"`
	TagProductList []interface{} `json:"tag_product_list"` //分类下的产品
	ChildTagList   []*TagItem    `json:"child_tag_list"`
}

type TagProduct struct {
	ProductId           int64              `json:"product_id"`
	Sn                  string             `json:"sn"`
	Title               string             `json:"title"`
	Cover               string             `json:"cover"`
	CoverMetadata       interface{}        `json:"cover_metadata"`
	SizeNum             uint32             `json:"size_num"`
	MinPrice            int64              `json:"min_price"`
	CoverDefault        []CoverDefaultItem `json:"cover_default"`
	HaveOptionalFitting bool               `json:"have_optional_fitting"`
	Recommended         bool               `json:"recommended"`
	IsCustomization     int64              `json:"is_customization"`
}

type CoverDefaultItem struct {
	TemplateTag   string      `json:"template_tag"`
	Cover         string      `json:"cover"`
	CoverMetadata interface{} `json:"cover_metadata"`
}

type GetModelByPidReq struct {
	Pid string `form:"pid"` //实际上是产品sn
}

type GetPriceByPidReq struct {
	Pid string `form:"pid"`
}

type GetPriceByPidRsp struct {
	Items     []PriceItem `json:"items"`
	MinPrice  float64     `json:"min_price"`
	MaxPrice  float64     `json:"max_price"`
	StepRange []StepRange `json:"step_range"`
}

type StepRange struct {
	Begin int64   `json:"begin"`
	End   int64   `json:"end"`
	Price float64 `json:"price"`
}

type PriceItem struct {
	Num      int64 `json:"num"`
	TotalNum int64 `json:"total_num"`
	Price    int64 `json:"price"`
}

type GetProductStepPriceReq struct {
	ProductId int64 `form:"product_id"`
}

type CalculateProductPriceReq struct {
	ProductId        int64 `json:"product_id"`
	SizeId           int64 `json:"size_id"`
	FittingId        int64 `json:"fitting_id,optional"`
	PurchaseQuantity int64 `json:"purchase_quantity"`
}

type CalculateProductPriceRsp struct {
	ItemPrice  string      `json:"item_price"`
	TotalPrice string      `json:"total_price"`
	StepRange  interface{} `json:"step_range"`
}

type GetSizeByPidReq struct {
	Pid         string `form:"pid"`
	TemplateTag string `form:"template_tag"`
}

type GetSizeByPidRsp struct {
	Id              int64       `json:"id"` //尺寸id
	Title           interface{} `json:"title"`
	Capacity        string      `json:"capacity"`          //容量、尺寸、尺码描述
	Cover           string      `json:"cover"`             //缩略图
	PartsCanDeleted bool        `json:"parts_can_deleted"` //用户可否删除配件
	ModelId         int64       `json:"model_id"`          //产品主模型id
	IsPopular       bool        `json:"is_popular"`        //是否受欢迎
	MinPrice        string      `json:"min_price"`         //最小价格
	IsDefault       bool        `json:"is_default"`        //是否默认（这里的默认是跟列表页一致）
}

type GetTemplateByPidReq struct {
	Pid           string `form:"pid"`
	ProductSizeId int64  `form:"product_size_id,optional"`
	TemplateTag   string `form:"template_tag"`
}

type GetFittingByPidReq struct {
	Pid string `form:"pid"`
}

type GetFittingByPidRsp struct {
	Id          int64       `json:"id"`
	MaterialImg string      `json:"material_img"`
	Title       string      `json:"title"`
	Price       string      `json:"price"`
	IsPopular   bool        `json:"is_popular"`
	ModelInfo   interface{} `json:"model_info"`
}

type GetLightByPidReq struct {
	Pid string `form:"pid"`
}

type GetRenderSettingByPidReq struct {
	Pid      string `form:"pid"`
	ClientNo string `form:"client_no,optional"`
}

type GetRenderSettingByPidRsp struct {
	Id              int64       `json:"id"`               //产品id
	Type            int64       `json:"type"`             //产品typeid
	Title           string      `json:"title"`            //产品名称
	IsEnv           int64       `json:"isEnv"`            //产品标签之一
	IsMicro         int64       `json:"isMicro"`          //产品标签之一
	TypeName        string      `json:"typeName"`         //产品类型名称
	IsLowRendering  bool        `json:"is_low_rendering"` //低质量画质渲染开关
	IsCustomization int64       `json:"is_customization"` //产品是否可定制
	IsRemoveBg      bool        `json:"is_remove_bg"`     //logo上传是否去背景
	RenderDesign    bool        `json:"render_design"`    //是否拥有云渲染设计方案
	LastDesign      bool        `json:"last_design"`      //是否拥有千人千面设计方案
	Colors          interface{} `json:"colors"`
}

type HomePageRecommendProductListReq struct {
	Size         uint32 `form:"size"`
	MerchantType int64  `form:"merchant_type"`
}

type HomePageRecommendProductListRsp struct {
	Id                  int64              `json:"id"`
	Sn                  string             `json:"sn"`
	Title               string             `json:"title"`
	Cover               string             `json:"cover"`
	CoverMetadata       interface{}        `json:"cover_metadata"`
	SizeNum             uint32             `json:"size_num"`
	MinPrice            int64              `json:"min_price"`
	CoverDefault        []CoverDefaultItem `json:"cover_default"`
	HaveOptionalFitting bool               `json:"have_optional_fitting"`
	IsCustomization     int64              `json:"is_customization"`
}

type Request struct {
}

type Response struct {
	Code    int         `json:"code"`
	Message string      `json:"msg"`
	Data    interface{} `json:"data"`
}

type Auth struct {
	AccessSecret string `json:"accessSecret"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type File struct {
	Filename string              `fsfile:"filename"`
	Header   map[string][]string `fsfile:"header"`
	Size     int64               `fsfile:"size"`
	Data     []byte              `fsfile:"data"`
}

type Meta struct {
	TotalCount  int64 `json:"total_count"`
	PageCount   int64 `json:"page_count"`
	CurrentPage int   `json:"current_page"`
	PerPage     int   `json:"per_page"`
}

// Set 设置Response的Code和Message值
func (resp *Response) Set(Code int, Message string) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
	}
}

// Set 设置整个Response
func (resp *Response) SetWithData(Code int, Message string, Data interface{}) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
		Data:    Data,
	}
}

// SetStatus 设置默认StatusResponse(内部自定义) 默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatus(sr *basic.StatusResponse, data ...interface{}) *Response {
	newResp := &Response{
		Code: sr.Code,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}

// SetStatusWithMessage 设置默认StatusResponse(内部自定义) 非默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatusWithMessage(sr *basic.StatusResponse, msg string, data ...interface{}) *Response {
	newResp := &Response{
		Code:    sr.Code,
		Message: msg,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}
