// Code generated by goctl. DO NOT EDIT.
package types

import (
	"fusenapi/utils/basic"
)

type LogoResizeReq struct {
	ResourceId string `form:"resource_id"`
	Width      int64  `form:"width"`
	Height     int64  `form:"height"`
}

type LogoResizeRes struct {
}

type LogoRemovebgReq struct {
	IsRemoveBg string `form:"is_remove_bg"`
	LogoFile   string `form:"logo_file"`
	Width      string `form:"width"`
	Height     string `form:"height"`
	Proportion string `form:"proportion"`
}

type ResourceInfoReq struct {
	ResourceId  string `form:"resource_id,optional"`  // 资源ID
	ResourceKey string `form:"resource_key,optional"` // 资源唯一标识
}

type LogoCombineReq struct {
	Resolution        string              `json:"resolution"` // 合图参数
	LogoUrl           string              `json:"logo_url"`   // 合图参数
	TemplateTagColor  TemplateTagColor    `json:"template_tag_color"`
	TemplateTagGroups []TemplateTagGroups `json:"template_tag_groups"`
	TemplateId        int64               `json:"template_id"`      // 合图参数
	TemplateTag       string              `json:"template_tag"`     // 合图参数
	Website           string              `json:"website,optional"` // 合图参数
	Slogan            string              `json:"slogan,optional"`  // 合图参数
	Address           string              `json:"address,optional"` // 合图参数
	Phone             string              `json:"phone,optional"`   // 合图参数
	Qrcode            string              `json:"qrcode,optional"`  // 合图参数
}

type TemplateTagColor struct {
	Colors             [][]string `json:"colors"`               // 颜色组合
	SelectedColorIndex int        `json:"selected_color_index"` // 主色的下标索引
}

type TemplateTagGroups struct {
	Tag   string `json:"tag"`
	Name  string `json:"name"`
	Value string `json:"value"`
	Fixed int64  `json:"fixed"`
}

type Request struct {
}

type Response struct {
	Code    int         `json:"code"`
	Message string      `json:"msg"`
	Data    interface{} `json:"data"`
}

type Auth struct {
	AccessSecret string `json:"accessSecret"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type File struct {
	Filename string              `fsfile:"filename"`
	Header   map[string][]string `fsfile:"header"`
	Size     int64               `fsfile:"size"`
	Data     []byte              `fsfile:"data"`
}

type Meta struct {
	TotalCount  int64 `json:"total_count"`
	PageCount   int64 `json:"page_count"`
	CurrentPage int   `json:"current_page"`
	PerPage     int   `json:"per_page"`
}

// Set 设置Response的Code和Message值
func (resp *Response) Set(Code int, Message string) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
	}
}

// Set 设置整个Response
func (resp *Response) SetWithData(Code int, Message string, Data interface{}) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
		Data:    Data,
	}
}

// SetStatus 设置默认StatusResponse(内部自定义) 默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatus(sr *basic.StatusResponse, data ...interface{}) *Response {
	newResp := &Response{
		Code: sr.Code,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}

// SetStatusWithMessage 设置默认StatusResponse(内部自定义) 非默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatusWithMessage(sr *basic.StatusResponse, msg string, data ...interface{}) *Response {
	newResp := &Response{
		Code:    sr.Code,
		Message: msg,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}
