package handler

import (
	"net/http"
	"reflect"

	"fusenapi/utils/basic"

	"fusenapi/server/upload/internal/logic"
	"fusenapi/server/upload/internal/svc"
	"fusenapi/server/upload/internal/types"
)

func UploadFileBaseHandler(svcCtx *svc.ServiceContext) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		// data, _ := io.ReadAll(r.Body)
		// log.Println(string(data))
		var req types.UploadFileBaseReq
		userinfo, err := basic.RequestParse(w, r, svcCtx, &req)
		if err != nil {
			return
		}

		// 创建一个业务逻辑层实例
		l := logic.NewUploadFileBaseLogic(r.Context(), svcCtx)

		rl := reflect.ValueOf(l)
		basic.BeforeLogic(w, r, rl)

		resp := l.UploadFileBase(&req, userinfo)

		if !basic.AfterLogic(w, r, rl, resp) {
			basic.NormalAfterLogic(w, r, resp)
		}
	}
}
